Subject: I/O timeout in nncp-daemon

From: John Goerzen <[email-masked]>
Date: Thu, 21 Jan 2021 17:55:15 -0600

Hi,

I've had a bit of a recurring problem.  Lines like this from 
nncp-daemon:

Jan 21 17:44:31 nncp nncp-daemon[867]: E 
2021-01-21T23:44:31.001040425Z [sp-xmit err="write tcp [elided]: 
i/o timeout" nice="255"...

The conditions that cause this tend to be:

1) The remote nncp-caller just received a 4GB packet and is now 
checking it, and nncp-daemon still has a bunch more packets for it

2) The remote nncp-call just started up and it waiting for a drive 
to spin up (apparently it makes the TCP connection before it does 
whatever it is that makes the drive spin up)

3) Basically situations where nncp-call(er) are a bit slow for 
some reason

This timeout is much lower than any of the deadlines set in the 
configuration file, and appears to be a few seconds.

What I don't know is if this could happen in nncp-call(er) as 
well; in my case, the nncp-call(er) machine has its spool on a USB 
HDD and the nncp-daemon is on a raidz2 array with fast drives.

I looked, unsuccessfully, for this in the source code.

Would it be possible to make this configurable, or larger?

Thanks!

- John